VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsJSON"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Compare Database
Option Explicit
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' JSON Class
'
' Arnel G. Puzon
' 25-August-2017
'
' Based on test data submitted:
'
' strTest = "[{""street"":""678 Willdrobe Dr."",""state"":""MI"",""zipcode"":""34567"",""city"":""Indiana""}]"
'
' To Call:
'
' Dim json As clsJSON
' Set json = New clsJSON
' json.Parse(strTest)
'
' Count     = Number of Columns or Fields in the text file
' Columns   = Returns an array of Column/Field names
' Items     = Returns the content of Column/Field
'
' Item(x)   = Returns the content of Column at index x (x is zero based)
' Column(x) = Returns the Column/Field name at index x (x is zero based)
'
' Columns and Items are zero (0) base
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Count As Integer

Private arrFields() As Variant
Private arrValues() As Variant

Public Sub Parse(ByVal strJSON As String)
    
    Dim arrFieldsAndValue As Variant
    Dim var As Variant, i As Integer
    Dim bolFirst As Boolean
    Dim arrTemp As Variant
    
    'remove leading and trailing
    strJSON = Replace(strJSON, "[", "")
    strJSON = Replace(strJSON, "{", "")
    strJSON = Replace(strJSON, "}", "")
    strJSON = Replace(strJSON, "]", "")

    bolFirst = True
    arrFieldsAndValue = Split(strJSON, ",")
    
    For Each var In arrFieldsAndValue
        
        arrTemp = Split(var, ":")
        
        For i = 0 To UBound(arrTemp) Step 2
            If Not bolFirst Then
                ReDim Preserve arrFields(UBound(arrFields) + 1)
                ReDim Preserve arrValues(UBound(arrFields) + 1)
            
            Else
                bolFirst = False
            End If
            'replace "" with "
            arrTemp(i) = Replace(arrTemp(i), Chr(34), "/")
            arrTemp(i) = Replace(arrTemp(i), "//", "")
            arrTemp(i) = Replace(arrTemp(i), "/", "")
            
            arrTemp(i + 1) = Replace(arrTemp(i + 1), Chr(34), "/")
            arrTemp(i + 1) = Replace(arrTemp(i + 1), "//", "")
            arrTemp(i + 1) = Replace(arrTemp(i + 1), "/", "")
            
            arrFields(UBound(arrFields)) = arrTemp(i)
            arrValues(UBound(arrValues)) = arrTemp(i + 1)
        Next i
    Next
    
    Count = UBound(arrFieldsAndValue) + 1
End Sub

Private Sub Class_Initialize()
    ReDim arrFields(0)
    ReDim arrValues(0)
End Sub

Private Sub Class_Terminate()
    Erase arrFields
    Erase arrValues
End Sub

Public Property Get Item(ByVal Index As Integer) As Variant
    If Index > -1 And Index <= Count Then Item = arrValues(Index)
End Property

Public Property Get Column(ByVal Index As Integer) As Variant
    If Index > -1 And Index <= Count Then Column = arrFields(Index)
End Property

Public Property Get Columns() As Variant
    Columns = arrFields
End Property

Public Property Get Items() As Variant
    Items = arrValues
End Property



